﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Linq;

namespace TestAPIServer.Controllers
{
    /// <summary>
    /// 신원 컨트롤러
    /// </summary>
    public class IdentityController : Controller
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 인덱스 페이지 처리하기 - Index()

        /// <summary>
        /// 인덱스 페이지 처리하기
        /// </summary>
        /// <returns>액션 결과</returns>
        [HttpGet]
        [Authorize("APIScope")]
        public IActionResult Index()
        {
            return new JsonResult(from claim in User.Claims select new { claim.Type, claim.Value });
        }

        #endregion
    }
}