using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

using IdentityServer4.Events;
using IdentityServer4.Extensions;
using IdentityServer4.Models;
using IdentityServer4.Services;
using IdentityServer4.Stores;

using TestIdentityServer.Attributes;
using TestIdentityServer.Models;

namespace TestIdentityServer
{
    /// <summary>
    ///  ο Ʈѷ
    /// </summary>
    /// <remarks> Ʈѷ ϸ ڰ Ŭ̾Ʈ ο    ִ.</remarks>
    [SecurityHeaders]
    [Authorize]
    public class GrantsController : Controller
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ſ  ȭ 
        /// </summary>
        private readonly IIdentityServerInteractionService identityServerInteractionService;

        /// <summary>
        /// Ŭ̾Ʈ 
        /// </summary>
        private readonly IClientStore clientStore;

        /// <summary>
        /// ҽ 
        /// </summary>
        private readonly IResourceStore resourceStore;

        /// <summary>
        /// ̺Ʈ 
        /// </summary>
        private readonly IEventService eventService;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - GrantsController(identityServerInteractionService, clientStore, resourceStore, eventService)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="identityServerInteractionService">ſ  ȭ </param>
        /// <param name="clientStore">Ŭ̾Ʈ </param>
        /// <param name="resourceStore">ҽ </param>
        /// <param name="eventService">̺Ʈ </param>
        public GrantsController(IIdentityServerInteractionService identityServerInteractionService, IClientStore clientStore, IResourceStore resourceStore, IEventService eventService)
        {
            this.identityServerInteractionService = identityServerInteractionService;
            this.clientStore                      = clientStore;
            this.resourceStore                    = resourceStore;
            this.eventService                     = eventService;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ε  óϱ - Index()

        /// <summary>
        /// ε  óϱ
        /// </summary>
        /// <returns>׼  ½ũ</returns>
        [HttpGet]
        public async Task<IActionResult> Index()
        {
            return View("Index", await BuildViewModelAsync());
        }

        #endregion
        #region   óϱ - Revoke(clientID)

        /// <summary>
        ///   óϱ
        /// </summary>
        /// <param name="clientID">Ŭ̾Ʈ ID</param>
        /// <returns>׼  ½ũ</returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Revoke(string clientID)
        {
            await this.identityServerInteractionService.RevokeUserConsentAsync(clientID);

            await this.eventService.RaiseAsync(new GrantsRevokedEvent(User.GetSubjectId(), clientID));

            return RedirectToAction("Index");
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region    (񵿱) - BuildViewModelAsync()

        /// <summary>
        ///    (񵿱)
        /// </summary>
        /// <returns> ο   ½ũ</returns>
        private async Task<GrantsViewModel> BuildViewModelAsync()
        {
            IEnumerable<Grant> grantEnumerable = await this.identityServerInteractionService.GetAllUserGrantsAsync();

            List<GrantViewModel> list = new List<GrantViewModel>();

            foreach(Grant grant in grantEnumerable)
            {
                Client client = await this.clientStore.FindClientByIdAsync(grant.ClientId);

                if(client != null)
                {
                    Resources resources = await this.resourceStore.FindResourcesByScopeAsync(grant.Scopes);

                    GrantViewModel vm = new GrantViewModel()
                    {
                        ClientID                    = client.ClientId,
                        ClientName                  = client.ClientName ?? client.ClientId,
                        ClientLogoURL               = client.LogoUri,
                        ClientURL                   = client.ClientUri,
                        Description                 = grant.Description,
                        Created                     = grant.CreationTime,
                        Expires                     = grant.Expiration,
                        IdentityGrantNameEnumerable = resources.IdentityResources.Select(x => x.DisplayName ?? x.Name).ToArray(),
                        APIGrantNameEnumerable      = resources.ApiScopes.Select(x => x.DisplayName ?? x.Name).ToArray()
                    };

                    list.Add(vm);
                }
            }

            return new GrantsViewModel
            {
                GrantEnumerable = list
            };
        }

        #endregion
    }
}