using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using System.Threading.Tasks;

using IdentityServer4.Models;
using IdentityServer4.Services;

using TestIdentityServer.Attributes;
using TestIdentityServer.Models;

namespace TestIdentityServer
{
    /// <summary>
    /// Ȩ Ʈѷ
    /// </summary>
    [SecurityHeaders]
    [AllowAnonymous]
    public class HomeController : Controller
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ſ  ȭ 
        /// </summary>
        private readonly IIdentityServerInteractionService identityServerInteractionService;

        /// <summary>
        ///  ȣƮ ȯ
        /// </summary>
        private readonly IWebHostEnvironment environment;
        
        /// <summary>
        /// α ϱ
        /// </summary>
        private readonly ILogger logger;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// public

        #region  - HomeController(identityServerInteractionService, environment, logger)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="identityServerInteractionService">ſ  ȭ </param>
        /// <param name="environment"> ȣƮ ȯ</param>
        /// <param name="logger">α ϱ</param>
        public HomeController(IIdentityServerInteractionService identityServerInteractionService, IWebHostEnvironment environment, ILogger<HomeController> logger)
        {
            this.identityServerInteractionService = identityServerInteractionService;
            this.environment                      = environment;
            this.logger                           = logger;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// public

        #region ε  óϱ - Index()

        /// <summary>
        /// ε  óϱ
        /// </summary>
        /// <returns>׼ </returns>
        public IActionResult Index()
        {
            if(this.environment.IsDevelopment())
            {
                return View();
            }

            this.logger.LogInformation("Homepage is disabled in production. Returning 404.");

            return NotFound();
        }

        #endregion
        #region   óϱ - Error(errorID)

        /// <summary>
        ///   óϱ
        /// </summary>
        /// <param name="errorID"> ID</param>
        /// <returns>׼  ½ũ</returns>
        public async Task<IActionResult> Error(string errorID)
        {
            ErrorViewModel vm = new ErrorViewModel();

            // ſ     Ѵ.
            ErrorMessage message = await this.identityServerInteractionService.GetErrorContextAsync(errorID);

            if(message != null)
            {
                vm.Error = message;

                if(!this.environment.IsDevelopment())
                {
                    message.ErrorDescription = null;
                }
            }

            return View("Error", vm);
        }

        #endregion
    }
}