﻿using System;

namespace TestIdentityServer.Models
{
    /// <summary>
    /// 계정 옵션
    /// </summary>
    public class AccountOptions
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 지역 로그인 허용 여부
        /// </summary>
        public static bool AllowLocalLogin = true;

        /// <summary>
        /// 로그인 기억 허용 여부
        /// </summary>
        public static bool AllowRememberLogin = true;

        /// <summary>
        /// 로그인 기억 기간
        /// </summary>
        public static TimeSpan RememberLoginDuration = TimeSpan.FromDays(30);

        /// <summary>
        /// 로그아웃 프롬프트 표시 여부
        /// </summary>
        public static bool ShowLogoutPrompt = true;

        /// <summary>
        /// 로그아웃 후 자동 재전송 여부
        /// </summary>
        public static bool AutomaticRedirectAfterLogout = false;

        /// <summary>
        /// 무효 자격 증명 에러 메시지
        /// </summary>
        public static string InvalidCredentialsErrorMessage = "Invalid username or password";

        #endregion
    }
}