﻿using System.Collections.Generic;
using System.Security.Claims;
using System.Text.Json;

using IdentityModel;
using IdentityServer4;
using IdentityServer4.Test;

namespace TestIdentityServer.Models
{
    /// <summary>
    /// 테스트 사용자 데이터
    /// </summary>
    public class TestUserData
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 사용자 리스트 - UserList

        /// <summary>
        /// 사용자 리스트
        /// </summary>
        public static List<TestUser> UserList
        {
            get
            {
                var address = new
                {
                    street_address = "One Hacker Way",
                    locality       = "Heidelberg",
                    postal_code    = 69118,
                    country        = "Germany"
                };
                
                return new List<TestUser>
                {
                    new TestUser
                    {
                        SubjectId = "818727",
                        Username  = "alice",
                        Password  = "alice",
                        Claims    =
                        {
                            new Claim(JwtClaimTypes.Name         , "Alice Smith"),
                            new Claim(JwtClaimTypes.GivenName    , "Alice"),
                            new Claim(JwtClaimTypes.FamilyName   , "Smith"),
                            new Claim(JwtClaimTypes.Email        , "AliceSmith@email.com"),
                            new Claim(JwtClaimTypes.EmailVerified, "true", ClaimValueTypes.Boolean),
                            new Claim(JwtClaimTypes.WebSite      , "http://alice.com"),
                            new Claim
                            (
                                JwtClaimTypes.Address,
                                JsonSerializer.Serialize(address),
                                IdentityServerConstants.ClaimValueTypes.Json
                            )
                        }
                    },
                    new TestUser
                    {
                        SubjectId = "88421113",
                        Username  = "bob",
                        Password  = "bob",
                        Claims    =
                        {
                            new Claim(JwtClaimTypes.Name         , "Bob Smith"),
                            new Claim(JwtClaimTypes.GivenName    , "Bob"),
                            new Claim(JwtClaimTypes.FamilyName   , "Smith"),
                            new Claim(JwtClaimTypes.Email        , "BobSmith@email.com"),
                            new Claim(JwtClaimTypes.EmailVerified, "true", ClaimValueTypes.Boolean),
                            new Claim(JwtClaimTypes.WebSite      , "http://bob.com"),
                            new Claim
                            (
                                JwtClaimTypes.Address,
                                JsonSerializer.Serialize(address),
                                IdentityServerConstants.ClaimValueTypes.Json
                            )
                        }
                    }
                };
            }
        }

        #endregion
    }
}